------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--                               C L I E N T                                --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--         Copyright (C) 2002-2004 Free Software Foundation, Inc.           --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
--
--
--
--
--
--
--
--                                                                          --
--                PolyORB is maintained by ACT Europe.                      --
--                    (email: sales@act-europe.fr)                          --
--                                                                          --
------------------------------------------------------------------------------

--   suma client.

with Ada.Command_Line;
with Ada.Text_IO;
with CORBA.ORB;
with CORBA.Object;

with Suma;
with Suma.Helper;

--with PolyORB.Setup.Client;
--pragma Warnings (Off, PolyORB.Setup.Client);

with Mi_PolyORB_Setup_Client;
pragma Warnings (Off, Mi_PolyORB_Setup_Client);

with PolyORB.Utils.Report;

with PolyORB.CORBA_P.Naming_Tools;

procedure Client is
   use Ada.Command_Line;
   use Ada.Text_IO;
   use PolyORB.Utils.Report;

   Num1, Num2, Result : CORBA.Long;
   Ref : CORBA.Object.Ref;
   Mysuma : Suma.Ref;
   Argv : CORBA.ORB.Arg_List := CORBA.ORB.Command_Line_Arguments;

begin
   New_Test ("Suma client");

   CORBA.ORB.Init (CORBA.ORB.To_CORBA_String ("ORB"), Argv);


   --  Getting object reference from nameserver

   Ref:= PolyORB.CORBA_P.Naming_Tools.Locate("AddServer");
   Mysuma := Suma.Helper.To_Ref(Ref);

   --  Checking if it worked

   if Suma.Is_Nil (Mysuma) then
      Put_Line ("main : cannot invoke on a nil reference");
      return;
   end if;

   --  Sending message

   Num1 := CORBA.Long'Value(Argument(1));
   Num2 := CORBA.Long'Value(Argument(2));
   Result := Suma.Sumalong(Mysuma, Num1, Num2);


   --  Printing result

   Put_Line ("Suma = " & CORBA.Long'Image (Result));


   End_Report;

exception
   when E : CORBA.Transient =>
      declare
         Memb : CORBA.System_Exception_Members;
      begin
         CORBA.Get_Members (E, Memb);
         Put ("received exception transient, minor");
         Put (CORBA.Unsigned_Long'Image (Memb.Minor));
         Put (", completion status: ");
         Put_Line (CORBA.Completion_Status'Image (Memb.Completed));

         End_Report;
      end;
end Client;
